#ifndef CLIB_MULTIUSER_PROTOS_H
#define CLIB_MULTIUSER_PROTOS_H
/*
**      $Filename: clib/multiuser_protos.h $
**      $Release: 1.4 $
**      $Revision: 39.5 $
**
**      C prototypes.
**
**      (C) Copyright 1993 Geert Uytterhoeven
**      All Rights Reserved
*/

ULONG muLogoutA(struct TagItem *taglist);
ULONG muLoginA(struct TagItem *taglist);
ULONG muGetTaskOwner(struct Task *task);
BOOL muPasswd(STRPTR oldpwd, STRPTR newpwd);
struct muUserInfo *muAllocUserInfo(void);
void muFreeUserInfo(struct muUserInfo *info);
struct muUserInfo *muGetUserInfo(struct muUserInfo *info, ULONG keytype);
BOOL muSetDefProtectionA(struct TagItem *taglist);
ULONG muGetDefProtection(struct Task *task);
BOOL muSetProtection(STRPTR name, LONG mask);
BOOL muLimitDOSSetProtection(BOOL flag);
BOOL muCheckPasswd(struct TagItem *taglist);
BPTR muGetPasswdDirLock(void);
BPTR muGetConfigDirLock(void);


  /*
   *     Private functions
   *
   *     Do NOT call them!!
   */

BOOL muFSRendezVous(void);


#endif  /* CLIB_MULTIUSER_PROTOS_H */
